import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/widgets.dart';
import 'package:stealth_id/stealth_id.dart';

class CredentialExample extends StatefulWidget {
  @override
  _CredentialExampleState createState() => _CredentialExampleState();
}

class _CredentialExampleState extends State<CredentialExample> {
  Map _credentialMessage = {"message": "response message here"};

  @override
  Widget build(BuildContext context) {
    return Container(
        child: Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Expanded(
          child: Padding(
              padding: EdgeInsets.only(top: 15),
              child: Text(
                "Renew Credentials Example",
                style: TextStyle(fontSize: 25, fontWeight: FontWeight.bold),
              )),
          flex: 1,
        ),
        Expanded(
          flex: 1,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceAround,
            children: [
              ElevatedButton.icon(
                icon: Icon(Icons.camera),
                label: Text("Renew Credential"),
                onPressed: __onCredentialClickHandler,
              ),
            ],
          ),
        ),
        Expanded(
          flex: 3,
          child: Center(
            child: Text(_credentialMessage.toString()),
          ),
        ),
      ],
    ));
  }

  void __onCredentialClickHandler() async {
    try {
      final retornoCapture = await StealthId.initiateClient();
      setState(() {
        _credentialMessage = retornoCapture;
      });
    } on PlatformException catch (error) {
      setState(() {
        _credentialMessage['status'] = error.code;
        _credentialMessage['message'] = error.message;
      });
    } catch (e) {
      print(e.toString());
    }
  }
}
