import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter/widgets.dart';
import 'package:stealth_id/stealth_id.dart';

class DocumentExample extends StatefulWidget {
  @override
  _DocumentExampleState createState() => _DocumentExampleState();
}

class _DocumentExampleState extends State<DocumentExample> {
  Map _captureMessage = {"message": "response message here"};

  @override
  Widget build(BuildContext context) {
    return Container(
        child: Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        Expanded(
          child: Padding(
              padding: EdgeInsets.only(top: 15),
              child: Text(
                "Document Example",
                style: TextStyle(fontSize: 32, fontWeight: FontWeight.bold),
              )),
          flex: 1,
        ),
        Expanded(
          flex: 3,
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceAround,
            children: [
              RaisedButton.icon(
                icon: Icon(Icons.account_box_outlined),
                label: Text("OCR User Test"),
                onPressed: __onCaptureORCClickHandler,
              ),
            ],
          ),
        ),
        Expanded(
          flex: 1,
          child: Center(
            child: Text(_captureMessage.toString()),
          ),
        ),
      ],
    ));
  }

  void __onCaptureORCClickHandler() async {
    try {
      final retornoCapture = await StealthId.captureOCR(
          <String, dynamic>{"userId": "60466b7ca029bb001e31fcb666"});
      setState(() {
        _captureMessage = retornoCapture;
      });
    } on PlatformException catch (error) {
      setState(() {
        _captureMessage['status'] = error.code;
        _captureMessage['message'] = error.message;
      });
    } catch (e) {
      print(e.toString());
    }
  }
}
